

module red_pitaya_FIRblock(
   input                 clk_i       , 
   input wire signed [ 30-1:0] dsp48A_i , 
   input wire signed [ 25-1:0] dsp48D_i ,
   input wire signed [ 18-1:0] dsp48B_i ,
   input wire signed [ 48-1:0] dsp48P_i ,
   output wire signed [ 48-1:0] dsp48A2_o ,
   output wire signed [ 48-1:0] dsp48P_o 
 );
 parameter Awidth = 30 ;
 parameter Dwidth = 25 ;
 parameter ADwidth = 25 ;
 
 parameter Bwidth = 18 ;
 parameter Cwidth = 32 ;
 
 
 parameter Mwidth = 72 ;
 parameter Pwidth = 48 ;

  reg  signed [Awidth-1: 0] A1 ;
  reg  signed [Awidth-1: 0] A2 ;
  assign dsp48A2_o = A2 ;  
  reg  signed [Dwidth-1: 0] D1 ;
  

  reg  signed [Pwidth-1: 0] P1 ;   
  assign dsp48P_o = P1 ;
  
  wire signed [ADwidth-1: 0] AD ; assign AD = $signed(A2+D1) ;
  reg  signed [ADwidth-1: 0] AD1 ;  
    
  wire signed [Mwidth-1: 0] M ; assign M = AD1*dsp48B_i ;
  reg  signed [Mwidth-1: 0] M1 ;

  always @(posedge clk_i) begin
    A1 <= dsp48A_i ;
    A2 <= A1 ;
    D1 <= dsp48D_i ;
    AD1 <= AD ;
    M1 <= M ;
    P1 <= M1 + dsp48P_i   ; 
    end

endmodule
