#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <complex.h> 
#include <unistd.h>
#include <sys/types.h> 

#include "config.h"
#include "fpga_awg.h"
#include "remez.h"

//***********************************************************************************************
double h[MAXtaps] ; 
int hSend[MAXtaps] ;
int nTapsFpga=0 ;
int nTaps=0 ;
int downsamplingFactor=0 ;
int testSignalPeriod=0 ;
int testmode=0 ;
int theShift=0 ;
int PARnumTaps ;
int loopThrough=0 ;

void shortTest1(){
  fprintf(stderr,"shortTest1()\n") ;
  for(int k=0 ; k<nTapsFpga ; k++){ h[k]=0 ; }
  testmode=1 ;
  downsamplingFactor=16 ; // all 16 clock pulses a FIR output-sample is generated
  theShift=14 ;
  testSignalPeriod=25 ; // all 25 output-saples a testpulse is generated
  // 15 taps can be used
  nTaps=15 ;


h[0]=-4000 ;  
h[1]=1500 ;
h[2]=2000 ;
h[3]=2500 ;
h[4]=3000 ;
h[5]=3500 ;
h[6]=4000 ;
h[7]=4500 ;
h[8]=5000 ;
h[9]=5500 ;
h[10]=6000 ;
h[11]=6500 ;
h[12]=7000 ;
h[13]=7500 ;
h[14]=4000 ;



/*
  h[13]=1000 ; h[12]=1000 ; h[11]=1000 ; h[10]=1000 ; h[9]=1000 ; h[8]=1000 ;  
  h[7]=1000 ;  h[6]=1000 ;  h[5]=1000 ;  h[4]=1000 ;  h[3]=1000 ;  h[2]=1000 ;
  h[1]=1000 ;  h[0]=1000 ; 
*/

/*
  h[13]=0 ; h[12]=0 ; h[11]=0 ; h[10]=0 ; h[9]=0 ; h[8]=0 ;  
  h[7]=0 ;  h[6]=0 ;  h[5]=0 ;  h[4]=0 ;  h[3]=0 ;  h[2]=0 ;
  h[1]=0 ;  h[0]=8000 ;  
*/


 
  }

void shortTest2(){
  fprintf(stderr,"shortTest2()\n") ;
  for(int k=0 ; k<nTapsFpga ; k++){ h[k]=0 ; }
  testmode=1 ;
  downsamplingFactor=16 ; // all 16 clock pulses a FIR output-sample is generated
  theShift=14 ;
  testSignalPeriod=20 ; // all 20 output-saples a testpulse is generated
  // 15 taps can be used
  nTaps=3 ;
  h[0]=6000 ; 
  h[1]=4000 ; 
  h[2]=2000 ; 
  }

void shortTest3(int test1){
  fprintf(stderr,"shortTest3()\n") ;
  for(int k=0 ; k<nTapsFpga ; k++){ h[k]=0 ; }
  testmode=test1 ;
  downsamplingFactor=8 ;
  theShift=14 ;
  testSignalPeriod=10 ; 
  // 15 taps can be used
  nTaps=4 ;
  h[0]=8000 ; 
  h[1]=8000 ; 
  h[2]=8000 ; 
  h[3]=8000 ; 
  }

void reverbTest1(){
fprintf(stderr,"reverbTest1()\n") ;
  fprintf(stderr,"FPGA   has %d taps\n",nTapsFpga) ;
  fprintf(stderr,"********** REVERB\n") ;

  for(int k=0 ; k<nTapsFpga ; k++){ h[k]=0 ; }
  #include "reverb1.c"
  hReverb1[0]+=0 ;
  if( nReverb1 != 8000 ){ fprintf(stderr,"Error: nReverb1 != 8000\n") ; exit(1) ; }
  nTaps=nReverb1 ;
  downsamplingFactor=nTaps+1 ;
  for(int k=0 ; k<nReverb1 ; k++){
    h[k]=hReverb1[k] ; 
    }
  testmode=1 ;
  testSignalPeriod=9000 ; 
  theShift=16 ;
  }

void pythonTest1(int testMode){
  fprintf(stderr,"pythonTest1()\n") ;
  for(int k=0 ; k<nTapsFpga ; k++){ h[k]=0 ; }
  testmode=testMode ;
  
  // 4095 taps can be used
  #include "pythonH1.c"
  if( nTaps2 != 4000 ){ fprintf(stderr,"Error: nTaps2 != 4000\n") ; exit(1) ; }
  testSignalPeriod=5000 ; // all 5000 output-saples a testpulse is generated
  nTaps=nTaps2 ;
  downsamplingFactor=nTaps+1 ;
  if(testMode){ 
    theShift=17 ;
    }
   else {
    theShift=26 ;
    }
  for(int k=0 ; k<nTaps ; k++){ h[k]=h2[k] ; }
  }

//***********************************************************************************************

void intro() {
  fpga_awg_init();
  //int magicWord= g_awg_reg->par0x48 ;
  nTapsFpga= g_awg_reg->par0x54 ;
  
 // printf("magicWord from FPGA=%8X\n",magicWord) ;
  printf("nTaps from FPGA=%8i\n",nTapsFpga) ;
  if( nTapsFpga != 16384 ){ fprintf(stderr,"Error: nTapsFpga != 16384\n") ; exit(1) ; }
  for(int k=0 ; k<nTapsFpga ; k++){ h[k]=0 ; }
//  if(nTaps>nTapsFpga){ fprintf(stderr,"nTAPS too big!") ; exit(1) ; }
  uint32_t *memPtr ;
  memPtr= (uint32_t *)g_awg_reg + (0x40 / sizeof(uint32_t));
  uint32_t date ;
  date=*memPtr ;
//  fprintf(stderr,"date=%08X",date) ; 
  // BitGen inserts the current time stamp into the 32-bit USR_ACCESS register in this format:
  // ddddd_MMMM_yyyyyy_hhhhh_mmmmmm_ssssss 
  // (bit 31) ................................................................. (bit 0)
  int seconds=(date>> 0) & (0x3F) ;
  int minutes=(date>> 6) & (0x3F) ;
  int hours  =(date>>12) & (0x1F) ;
  int years  =(date>>17) & (0x3F) ;
  int month  =(date>>23) & (0x0F) ;
  int day    =(date>>27) & (0x1F) ;
  fprintf(stderr,"date    %02d.%02d.%02d time %02d:%02d:%04d\n",day,month,2000+years,hours,minutes,seconds) ; 
  fpga_awg_exit();
  } 

FIRSpecification filterSpec ;

void saveToFpga(){
  int k ;
  if(downsamplingFactor<nTaps+1){ 
    downsamplingFactor=nTaps+1 ; 
    fprintf(stderr,"adjusted downsamplingFactor=%d",downsamplingFactor) ; 
    }
  if(testSignalPeriod<downsamplingFactor+1){ 
    testSignalPeriod=downsamplingFactor+1 ;
    fprintf(stderr,"  adjusted testSignalPeriod=%d",testSignalPeriod) ; 
    }
  fprintf(stderr,"  reorder coeffs now\n") ;
  k=nTaps ;
  hSend[k]=h[nTaps-1] ;
  int withProt1=0 ;
  if(withProt1){ fprintf(stderr,"hSend[%d]=%d\n",k,hSend[k]) ; }
  for(k=0 ; k<nTaps-1 ; k++){
    hSend[k]=h[nTaps-2-k] ;
    if(withProt1){ fprintf(stderr,"hSend[%d]=%d\n",k,hSend[k]) ; }
    }
  fprintf(stderr,"set filter coeffs now, nTapsFpga=%d\n",nTapsFpga) ;
  for(int k=0 ; k<nTapsFpga ; k++){
    g_awg_cha_mem[k] = hSend[k] ;
    }
  
  if(0){ // loopthrough test
    theShift=0 ;
    loopThrough=1 ;
    downsamplingFactor=1 ;
    testmode=0 ;
    }


  fprintf(stderr,"setFPGA: downsamplingFactor=%d",downsamplingFactor) ;
  fprintf(stderr,"  testSignalPeriod=%d",testSignalPeriod) ;
  fprintf(stderr,"  shift=%d",theShift) ;
  fprintf(stderr,"  loopThrough=%d",loopThrough) ;
  fprintf(stderr,"  testmode=%d\n",testmode) ;
 
  fprintf(stderr,"fSample= %15.5f kHz\n",125.0e6/downsamplingFactor/1e3) ;
  
  g_awg_reg->par0x50 = downsamplingFactor-1 ; 
  g_awg_reg->par0x44 = testSignalPeriod-1 ; 
  g_awg_reg->par0x48 = theShift ; // shift
  g_awg_reg->par0x40 = (loopThrough<<1) ;
  if(testmode==1){
    g_awg_reg->par0x4C = 0xFFFF ; // index=0xFFF means testmode
    }
   else {
    g_awg_reg->par0x4C = 0 ;   // index != 0xFFF means filter mode
    }
  }
 

void doScaleToGain(){
  fprintf(stderr,"PARnumTaps=%d\n",PARnumTaps) ;
  int showHsum=0 ; if(showHsum){
    double hSum=0.0 ;
    for(int k=0 ; k<PARnumTaps ; k++){ hSum += h[k] ; }
    fprintf(stderr,"sum(hk)=%15.5f\n",hSum) ;
    }
  for(int k=0 ; k<4 ; k++){ fprintf(stderr,"h[%2d]=%15.5f\n",k,h[k]); }
  nTaps=PARnumTaps ;
  fprintf(stderr,"filter has %d taps",nTaps) ;
  fprintf(stderr,"   FPGA   has %d taps\n",nTapsFpga) ;
  double hMax=0 ;
  for(int k=0 ; k<nTaps ; k++){ if (fabs(h[k]) >hMax ){ hMax=fabs(h[k]) ; } } ;
  fprintf(stderr,"hMax=%15.5f",hMax) ;
  int maxH=16384*8-1 ;
  int factor=1 ;
  int logFactor=0 ;
  while ( (int)(2*factor*hMax) <= maxH){
    factor *= 2 ;
    logFactor +=1 ;
    }
  fprintf(stderr,"  factor=%15d",factor) ;
  fprintf(stderr,"  logFactor=%15d",logFactor) ;
  theShift=logFactor ;
  double theScale=factor ;
  for( int k=0 ; k<nTaps ; k++){
    h[k]=(int) (theScale*h[k]) ;
    }
  hMax=0 ;
  for(int k=0 ; k<nTaps ; k++){ if (fabs(h[k]) >hMax ){ hMax=fabs(h[k]) ; } } ;
  fprintf(stderr,"  hMax now %15.5f\n",hMax) ;
  return ;
  }





void doScaleToMax(){
  fprintf(stderr,"PARnumTaps=%d\n",PARnumTaps) ;
  int showHsum=0 ; if(showHsum){
    double hSum=0.0 ;
    for(int k=0 ; k<PARnumTaps ; k++){ hSum += h[k] ; }
    fprintf(stderr,"sum(hk)=%15.5f\n",hSum) ;
    }
  for(int k=0 ; k<4 ; k++){ fprintf(stderr,"h[%2d]=%15.5f\n",k,h[k]); }
  nTaps=PARnumTaps ;
  fprintf(stderr,"filter has %d taps\n",nTaps) ;
  fprintf(stderr,"FPGA   has %d taps\n",nTapsFpga) ;
  double hMax=0 ;
  for(int k=0 ; k<nTaps ; k++){ if (fabs(h[k]) >hMax ){ hMax=fabs(h[k]) ; } } ;
  fprintf(stderr,"hMax=%15.5f\n",hMax) ;
 // double autoScale=wantedMax/hMax ;
//  int maxH=16384*4-1 ;
//  int maxH=16384*8-1 ;
  int maxH=100000 ;
  double factor=maxH/hMax ;
  fprintf(stderr,"factor=%15.5f\n",factor) ;
  theShift=17 ;
  hMax=0 ;
  for( int k=0 ; k<nTaps ; k++){ 
    h[k]=(int) (factor*h[k]) ; 
    if (fabs(h[k]) >hMax ){ hMax=fabs(h[k]) ; } 
    }
  fprintf(stderr,"h Max is now %15.5f\n",hMax) ;
  testmode=1 ;
  return ;
  }

void PMscaleToGain(){
  fprintf(stderr,"filterSpec.order=%5i\n",filterSpec.order) ;
  double *hk=design(filterSpec,nTapsFpga,&PARnumTaps) ;
  fprintf(stderr,"\n") ;
  for(int k=0 ; k<PARnumTaps ; k++){ h[k]=hk[k] ; }
  doScaleToGain() ;
  }

void PMscaleToMax(){
  fprintf(stderr,"filterSpec.order=%5i\n",filterSpec.order) ;
  double *hk=design(filterSpec,nTapsFpga,&PARnumTaps) ;
  fprintf(stderr,"\n") ;
  for(int k=0 ; k<PARnumTaps ; k++){ h[k]=hk[k] ; }
  doScaleToMax() ;
  }


void simple1(){
  downsamplingFactor=16 ;
  testSignalPeriod=32 ; 
  nTaps=15 ;
  h[0]=130000 ; h[1]=100000 ; h[2]=70000 ; h[3]=40000 ; 
  testmode=1 ;
  theShift=17 ;
  }

void gainOne0(){
  downsamplingFactor=1 ;
  testSignalPeriod=10 ; 
  nTaps=1 ;
  h[0]=131000 ;  
  testmode=0 ;
  theShift=17 ;
  }


void gainOne1(){
  downsamplingFactor=8 ;
  testSignalPeriod=10 ; 
  nTaps=7 ;
  h[0]=131000 ;  
  testmode=0 ;
  theShift=17 ;
  }



void gainOne2(){
  downsamplingFactor=8 ;
  testSignalPeriod=10 ; 
  nTaps=7 ;
  h[0]=131000/2 ;  
  testmode=0 ;
  theShift=17-1 ;
  }

void gainOneLP1(){
  downsamplingFactor=8 ;
  testSignalPeriod=10 ; 
  nTaps=7 ;
  h[0]=131000 ;  
  h[1]=131000 ;  
  h[2]=131000 ;  
  h[3]=131000 ;  
  testmode=0 ;
  theShift=17+2 ;
  }

void scaleChk1(){
  PMscaleToGain() ;
  }
void pmLPtest1(int testOn){
  fprintf(stderr,"set LPFTEST1\n") ;
  filterSpec.shape = LPF ;
  filterSpec.f1=0 ;
  filterSpec.f2=(double) 10e6 ;
  filterSpec.ft=(double) 4e6 ; // width of transition band
  filterSpec.dBatten=60 ;
  filterSpec.dBripple=1 ;
  filterSpec.fN=(double) ( 125e6/2.0) ;
  filterSpec.order=126 ;
  filterSpec.mod=0 ;
  if( testOn ){ PMscaleToMax() ; } else { PMscaleToGain() ; }
  }



void pmLPtest2(int testOn){
  fprintf(stderr,"set LPFTEST2\n") ;
  filterSpec.shape = LPF ;
  filterSpec.f1=0 ;
  filterSpec.f2=(double) 0.5e6 ;
  filterSpec.ft=(double) 0.4e6 ; // width of transition band
  filterSpec.dBatten=60 ;
  filterSpec.dBripple=1 ;
  filterSpec.fN=(double) ( 125e6/2.0) ;
  filterSpec.order=1022 ;
  filterSpec.mod=0 ;
   if( testOn ){ PMscaleToMax() ; } else { PMscaleToGain() ; }
  }

void pmBPtest1(int testOn){
  fprintf(stderr,"set BPFTEST\n") ;
  double fMidth=4e6 ;
  double fBandwidth=0.6e6;
  filterSpec.shape = BPF ;
  filterSpec.f1=fMidth-fBandwidth/2 ;
  filterSpec.f2=fMidth+fBandwidth/2 ;
  filterSpec.ft=(double) 0.3e6-0.2e6 ; // width of transition band
  filterSpec.dBatten=75 ;
  filterSpec.dBripple =2.5;
  filterSpec.fN=(double) ( 125e6/2.0) ;
  filterSpec.mod=0 ;
  filterSpec.order=-1 ;
   if( testOn ){ PMscaleToMax() ; } else { PMscaleToGain() ; }
  }

void pmHPtest1(int testOn){
  fprintf(stderr,"set HPFTEST\n") ;
  filterSpec.shape = HPF ;
  filterSpec.f1=(double) 10e6 ;
  filterSpec.ft=(double) 0.4e6 ; // width of transition band
  filterSpec.dBatten=50 ;
  filterSpec.fN=(double) ( 125e6/2.0) ;
  //filterSpec.order=52 ;
  filterSpec.order=-1 ;
  filterSpec.dBripple=1 ;
  filterSpec.mod=0 ;
  if( testOn ){ PMscaleToMax() ; } else { PMscaleToGain() ; }
  }

void pmBSFtest1(int testOn){
  fprintf(stderr,"set BSFTEST\n") ;
  filterSpec.shape = BSF ;
  double fMidth=10e6 ;
  double fBandwidth=2e6 ;
  filterSpec.f1=fMidth-fBandwidth/2 ;
  filterSpec.f2=fMidth+fBandwidth/2 ;
  filterSpec.ft=(double) 0.4e6 ; // width of transition band
  filterSpec.dBatten=60 ;
  filterSpec.dBripple =5 ;
  filterSpec.fN=(double) ( 125e6/2.0) ;
//    filterSpec.order=-1 ;
  filterSpec.order=900 ;
  filterSpec.mod=0 ;
  if( testOn ){ PMscaleToMax() ; } else { PMscaleToGain() ; }
  }


void gainChk1(){
  PARnumTaps=2 ;
  h[0]=2 ;
  h[1]=2 ;
//  h[2]=2 ;
//  h[3]=2 ;
//  h[4]=2 ;
  double sum=0 ;
  for(int k=0 ; k<PARnumTaps ; k++){ sum += h[k] ; }
  for(int k=0 ; k<PARnumTaps ; k++){ h[k]=h[k]/sum ; }
  downsamplingFactor=8 ;
  doScaleToGain() ;
  }


void PMtest1( ){
  intro() ;
  fpga_awg_init();



// shortTest1() ; 
//  shortTest2() ; 
// int test1= ; shortTest3(test1) ; 
//int test1=0 ; shortTest3(test1) ; 
//int test1=1 ; pythonTest1(test1) ;
//int test1=0 ; pythonTest1(test1) ;
//reverbTest1() ;
pmLPtest1(0) ;
//pmLPtest2(1) ;
//pmBPtest1(1) ;
//pmHPtest1(1) ;
//pmBSFtest1(0) ;
//simple1() ;
//gainOne0() ;
//gainOne1() ;
//gainOne2() ;
//gainOneLP1() ;
//  gainChk1() ;
  saveToFpga() ;
  fpga_awg_exit();
  }

