`default_nettype none
//https://groups.google.com/forum/#!topic/comp.lang.verilog/RwF6aRdlP2I


module red_pitaya_FIRfilter
#( parameter size = 1024 , parameter  adrWidth=10 , parameter xkWidth = 14 , parameter bkWidth = 18, parameter SumWidth = 48  )
( input wire              clk_i,  
  input wire                   rstn_i,
  input wire                   buf_we_i,    //!< buffer write enable
  input wire  [ adrWidth-1: 0] buf_addr_i,  //!< buffer address
  input wire  [ bkWidth-1: 0]  buf_wdata_i, //!< buffer write data
  input wire  [ xkWidth-1: 0]  filterIn_i,
  input wire  [ 8-1: 0]        scale_i,
  input wire  [8-1:0]          FIRoptions_i,
  input wire  [ 16-1: 0]       length_i,
  output wire [ 14-1: 0]       filterOut_o,
  output wire                  sample_o    
  );

reg signed [ bkWidth-1: 0] bk[size-1:0] ;
reg signed [ xkWidth-1: 0] xk[size-1:0] ;

always @(posedge clk_i) begin
  if (buf_we_i)
    bk[buf_addr_i] <= buf_wdata_i[bkWidth-1:0] ;
  end

reg   [adrWidth-1: 0] timer  ;
reg   [adrWidth-1: 0] timer2  ;
reg   [adrWidth-1: 0] wrPos  ;
reg   [adrWidth-1: 0] rdPos  ;

reg signed [SumWidth-1: 0] sum  ;

wire strobe ;
assign strobe=(timer==length_i );
assign sample_o = strobe ;

always @(posedge clk_i) begin
  timer2 <= timer ;
  if (strobe) begin
    xk[wrPos] <= filterIn_i ;
    wrPos <= wrPos + 1 ;
    rdPos <= wrPos + 1 ;
    sum <= 0 ;
    timer <= 0 ;
    end 
   else begin
    timer <= timer + 1 ;
    rdPos <= rdPos + 1 ;
    sum <= sum + bk[timer2] * xk[rdPos] ;
    end
  end


/*    
  assign strobe=(timer==nSteps-1 );
  assign sample_o = strobe ;
  
  always @(posedge clk_i) begin
    timer <= timer + 1 ;
    if (strobe) begin
      xk[wrPos] <= filterIn_i ;
      wrPos <= wrPos + 1 ;
      rdPos <= wrPos + 1 ;
      sum <= 0 ;
      end 
     else begin
      rdPos <= rdPos + 1 ;
      sum <= sum + bk[timer] * xk[rdPos] ;
      end
    end
      
*/
reg signed [SumWidth-1: 0] sum2  ;
 always @(posedge clk_i) begin
   if (strobe) begin
   if( FIRoptions_i[1:1]==1 ) begin
     sum2<=filterIn_i ; // loop_through
     end
    else begin
     sum2<= sum ;
     end
   end  
   end
outputSelector select1( 
  .clk_i(clk_i), 
  .ena_i(strobe), 
  .FIRsum_i(sum2),
  .selector_i(scale_i),
  .FIRout_o(filterOut_o ) 
   ) ;
    
endmodule


`default_nettype wire